/***************************************************************************


    ========== licence begin  GPL
    Copyright (c) 2000-2005 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end




*/
/* DbpInstall.idl : IDL source for DbpInstall.dll                               */
/****************************************************************************/
/* This file will be processed by the MIDL tool to
 * produce the type library (DBPINSTALLLIB.tlb).
 * The library (DBPINSTALLLIB.tlb) will be included as a 'resource' 
 * into DbpInstall.dll.
 */ 
/* **** IDL File for generating a COM Object defining DB-Procedures ***/

[ uuid(A435CDA6-A24E-11d3-A996-00A0C94311A5) ]
library DBPINSTALLLIB
{

  const char LiveCacheApplVersion = "V72";    
  import "livecachetypes.idl";

  typedef 
      [ uuid(EE4B31FA-CF89-11d1-A955-00A0C9430731),public ] 
      OmsTypeChar CPath[250];

  typedef OmsTypeChar CProgId[250];

  typedef 
      [ uuid(E707A1B1-1255-11d2-A968-00A0C9430731),public ]
      unsigned char UCHAR;

  typedef 
      [ uuid(B1397DF1-9962-11d1-A94F-00A0C9430731), public ]
      struct DllHandle {
          UCHAR*              RowDef;
          OmsTypeStreamHandle Handle;
      } DllHandle;

	[ uuid(FC2F8867-6983-11D2-A97F-00A0C94311A5) ]
    interface IDbpInstall : IUnknown
    {
        HRESULT COPY_AND_REG_DLL([in] CPath *DllName, 
            [in]  DllHandle * Handle, 
            [in] int regDll);
        HRESULT ACTIVATE_DLL([in] CProgId *pProgId);
        HRESULT REG_DLL([in] CPath *Path);
        HRESULT SYSDDLTRIGGER();
        HRESULT FORCE_CHECKPOINT([out] OmsTypeInt4* chptId);
        HRESULT WAIT_FOR_CHECKPOINT([in] OmsTypeInt4 chptId);
        HRESULT FORCE_AND_WAIT_FOR_CHECKPOINT();
        HRESULT DROP_SCHEMAS();
        HRESULT OMS_CLEANUP_AFTER_INIT();
    };

	[ uuid(A435CDA8-A24E-11d3-A996-00A0C94311A5) ]
	coclass DbpInstall
	{
		[default] interface IDbpInstall;
	};
};
